/* Provide hints for Tamarin's heuristics.
   In this case, we tell Tamarin to delay (make "Last", "L_") finding the
   sources for the LogCloud and LogDevice facts, since they don't provide useful information
   and can lead to non-termination. */
define(`LogCloud',`L_LogCloud($*)')
define(`LogDevice',`L_LogDevice($*)')
define(`Device',`F_Device($*)')

theory DECIM_secrecy

/* Include DECIM model */
include(`DECIM-base.inc')
// Fix syntax mixup: ')

/* Basic secrecy property */
lemma message_secrecy:
 "All R skR ekR m #i.
      /* If S sent a message m to R */
      ( MsgSent(R, skR, ekR, m) @ #i &
        /* without the adversary compromising any device */
        not (Ex #j d sk dkR. 
                Compromise_Device(d, R, sk, dkR) @ #j)
      )
      ==>
      ( /* then the adversary cannot know m */
        not ( Ex #j. K(m) @ #j)
      )
 "

end

// vi:ft=spthy 
